#include "../OneNETMqttClient/OneNETMqttClient.h"
#include <pthread.h>





OneNetMqttDevice dev;   //定义设备
char mqttpayload[2048];   //payload缓存大小
pthread_t mqtt_RecvData_id;    //接收数据处理进程
pthread_t mqtt_auth_RecvData_id; 

int number = 1;
char strdata[200] = "test";
char bindata[200] = {0x11,0x12,0x13,0x14,0x15};
double float_1 = 25.63;
int is_auth_X509_ok = 0;
DataStream testdata[2];
DataStream bindatastream;

//标准类型数据初始化
void DataInit(){
	testdata[0].dataPoint = &number;
	testdata[0].name = INTEGER_NAME;
	testdata[0].dataType = TYPE_INT;
	testdata[0].flag = true;
	testdata[1].dataPoint = strdata;
	testdata[1].name = STRING_NAME;
	testdata[1].dataType = TYPE_STRING;
	testdata[1].flag = true;
	bindatastream.dataPoint = bindata;
	bindatastream.name = "bindata";
	bindatastream.dataType = TYPE_BIN;
	bindatastream.datalen = 5;
	bindatastream.flag = true;
}


void main(void){
    
	int rc = 0;
	//初始化设备
    OneNETMQTTDeviceInit(&dev);
    
    //连接平台
	if(!OneNETMQTTConnect())  goto exit;

#ifdef USE_X509_AUTH   
	extern OneNetMqttDevice* mqttdev;
	is_auth_X509_ok = 0;
	setCstringData(&mqttdev->topic.cmd_dev_x509_auth, "auth/identity/response");
	MQTTSetMessageHandler(&mqttdev->client, mqttdev->topic.cmd_dev_x509_auth, OneNETStandardAuthCmdHandler);
	pthread_create(&mqtt_auth_RecvData_id, NULL, OneNETMQTTReceiveX509DeviceDataMultiThread, NULL);
	while(is_auth_X509_ok == 0)
	{
		printf("waiting for did pid\r\n");
		sleep(1);
	}
	pthread_join(mqtt_auth_RecvData_id,NULL);
	setUserTopicName(&mqttdev->topic,MODEL,mqttdev->devInfo.device_id,mqttdev->devInfo.product_id);
	
#endif
	//订阅平台命令
	if (!OneNETMQTTSubscribeSetTopic(OneNETStandardCmdHandler_V5))  goto exit;
	if (!OneNETMQTTSubscribeGetTopic(OneNETStandardCmdHandler_V5))  goto exit;
	if (!OneNETMQTTSubscribePostReplyTopic(OneNETStandardCmdHandler_V5))  goto exit;

	//创建线程，定时循环接受数据
	pthread_create(&mqtt_RecvData_id, NULL, OneNETMQTTReceiveDataMultiThread, NULL);
	DataInit();
	//UpdateShadowFirstTime();
	while(1)
	{
	    int lenth = 0;
        number++;
        sleep(10);
		lenth = OneNETMQTTStandardDataPacket_V5(mqttpayload, sizeof(mqttpayload));
#ifdef MQTT_TASK
		pthread_mutex_lock(&dev.client.mutex);
#endif
        if(!OneNETMQTTPublishData(mqttpayload, lenth)) goto exit;	
#if defined(MQTT_TASK)
		pthread_mutex_unlock(&dev.client.mutex);
#endif	

	}
exit:
    //断开设备连接和网络
	MQTTDisconnect(&dev.client);
	NetworkDisconnect(&dev.network);
}

